using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace LocationBasedMessenger
{
	/// <summary>
	/// Summary description for GPSSettings.
	/// </summary>
	public class GPSSettings : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuok;
		private System.Windows.Forms.MenuItem mnucancel;
		private System.Windows.Forms.Label lblport;
		private System.Windows.Forms.Label lblbaud;
		private System.Windows.Forms.ComboBox cbport;
		private System.Windows.Forms.ComboBox cbbaud;
		private System.Windows.Forms.CheckBox cbautodiscovery;
		private Settings settings = new Settings();
	
		public GPSSettings()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cbport = new System.Windows.Forms.ComboBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuok = new System.Windows.Forms.MenuItem();
			this.mnucancel = new System.Windows.Forms.MenuItem();
			this.cbbaud = new System.Windows.Forms.ComboBox();
			this.lblport = new System.Windows.Forms.Label();
			this.lblbaud = new System.Windows.Forms.Label();
			this.cbautodiscovery = new System.Windows.Forms.CheckBox();
			// 
			// cbport
			// 
			this.cbport.Location = new System.Drawing.Point(56, 56);
			this.cbport.Size = new System.Drawing.Size(88, 21);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.Add(this.mnuok);
			this.mainMenu1.MenuItems.Add(this.mnucancel);
			// 
			// mnuok
			// 
			this.mnuok.Text = "OK";
			this.mnuok.Click += new System.EventHandler(this.mnuok_Click);
			// 
			// mnucancel
			// 
			this.mnucancel.Text = "Cancel";
			this.mnucancel.Click += new System.EventHandler(this.mnucancel_Click);
			// 
			// cbbaud
			// 
			this.cbbaud.Location = new System.Drawing.Point(56, 88);
			this.cbbaud.Size = new System.Drawing.Size(88, 21);
			// 
			// lblport
			// 
			this.lblport.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Bold);
			this.lblport.Location = new System.Drawing.Point(8, 56);
			this.lblport.Size = new System.Drawing.Size(48, 22);
			this.lblport.Text = "Port:";
			// 
			// lblbaud
			// 
			this.lblbaud.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Bold);
			this.lblbaud.Location = new System.Drawing.Point(8, 88);
			this.lblbaud.Size = new System.Drawing.Size(48, 22);
			this.lblbaud.Text = "Baud:";
			// 
			// cbautodiscovery
			// 
			this.cbautodiscovery.Location = new System.Drawing.Point(48, 16);
			this.cbautodiscovery.Size = new System.Drawing.Size(112, 20);
			this.cbautodiscovery.Text = "Autodiscovery";
			this.cbautodiscovery.CheckStateChanged += new System.EventHandler(this.cbautodiscover_CheckStateChanged);
			// 
			// GPSSettings
			// 
			this.Controls.Add(this.cbautodiscovery);
			this.Controls.Add(this.lblport);
			this.Controls.Add(this.cbbaud);
			this.Controls.Add(this.cbport);
			this.Controls.Add(this.lblbaud);
			this.Menu = this.mainMenu1;
			this.Text = "Settings";
			this.Load += new System.EventHandler(this.GPSSettings_Load);

		}
		#endregion

		private void mnuok_Click(object sender, System.EventArgs e)
		{
			settings.ComPort=cbport.SelectedValue.ToString();
			settings.BaudRate=cbbaud.SelectedItem.ToString();
			settings.AutoDiscovery=this.cbautodiscovery.Checked;
			this.DialogResult=DialogResult.OK;
		}

		private void mnucancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult=DialogResult.Cancel;
		}

		private void GPSSettings_Load(object sender, System.EventArgs e)
		{
			this.cbport.DataSource=settings.COMDevices();
			string regport=settings.ComPort;
			int intindex=0;
			cbport.SelectedIndex=0;
			foreach(string listport in cbport.Items)
			{
				if (listport==regport)
				{
					cbport.SelectedIndex=intindex;
					break;
				}
				intindex++;

			}

			this.cbbaud.Items.Clear();
			this.cbbaud.Items.Add("1200");
			this.cbbaud.Items.Add("4800");
			this.cbbaud.Items.Add("9600");
			this.cbbaud.Items.Add("19200");
			
			string regbaud=settings.BaudRate;
			intindex=0;
			cbbaud.SelectedIndex=0;
			foreach(string listbaud in cbbaud.Items)
			{
				if (listbaud==regbaud)
				{
					cbbaud.SelectedIndex=intindex;
					break;
				}
				intindex++;

			}

			this.cbautodiscovery.Checked=settings.AutoDiscovery;
			autodiscovery_buttonhandler();

			
		}

		private void autodiscovery_buttonhandler()
		{
			if (this.cbautodiscovery.Checked)
			{
				cbbaud.Enabled=false;
				cbport.Enabled=false;
			}
			else
			{
				cbbaud.Enabled=true;
				cbport.Enabled=true;;

			}
		}

		private void cbautodiscover_CheckStateChanged(object sender, System.EventArgs e)
		{
			autodiscovery_buttonhandler();
		}
	}
}
