using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using OpenNETCF.IO.Serial.GPS;

namespace LocationBasedMessenger
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu2;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button start;
		private System.Windows.Forms.MenuItem SetupGPS;
		private System.Windows.Forms.MenuItem ServiceSetup;
		private System.Windows.Forms.MainMenu mainMenu1;
		Settings settings = new Settings();
		GPS gps = new GPS();
		private System.Windows.Forms.MenuItem ExitMessenger;
		bool exit = false;

		#region GPS specific
		private void gps_GpsCommState(object sender, GpsCommStateEventArgs e)
		{
			switch (e.State)
			{
				case OpenNETCF.IO.Serial.GPS.States.Running:
					menuItem4.Text="Stop Messenger";
					//status("GPS Started");
					break;
				case OpenNETCF.IO.Serial.GPS.States.Stopped:
					// New 31/01/05
					if (exit!=true)
					{
						menuItem4.Text="Start Messenger";
						//do not display it
						//setupuitext(this,"GPS");
						//status("GPS Stopped");
					}
					break;
			}
		}
		private void gps_GpsStatus(object sender, GpsStatusEventArgs e)
		{
			if (e.GpsStatus==OpenNETCF.IO.Serial.GPS.StatusType.OK)
			{
				//	status("Fix Established");
			}
			else
			{
				//status("No Fix");
			}
		}
		private void gps_Movement(object sender, objMovement mov)
		{
			string strspeed=mov.SpeedMph+" mp/h";
			string strtrack=mov.Track.ToString("000")+"";
			
			/*if (strspeed!=lblspeed.Text)
			{
				setupuitext(lblspeed,strspeed);
			}
			
			if (lbltrack.Text!=strtrack)
			{
				setupuitext(lbltrack,strtrack);
			}*/
		}
		private void gps_Fix(object sender, objPosition pos, FixType fixtype)
		{
			string strlong =pos.Longitude_Sexagesimal+" "+pos.DirectionLongitude;
			string strlat=pos.Latitude_Sexagesimal+" "+pos.DirectionLatitude;
			// added 01/27/2005
			DateTime dttime=pos.SatTime;
			/*if (strlong!=lblong.Text)
			{
				setupuitext(lblong,strlong);
			}

			if (strlat!=lblat.Text)
			{
				setupuitext(lblat,strlat);
			}*/
			if (fixtype==FixType.WithAltitude)
			{
				// modified 01/27/2005
				// add pos.GeoidSeparation if exist
				string stralt=pos.Altitude+pos.GeoidSeparation+"m";
				// modified 01/27/2005
				/*if (this.lbalt.Text!=stralt)
				{
					// modified 01/27/2005
					//setupuitext(lbalt,stralt);
				}*/
			}
			else
			{
				// modified 01/27/2005
				/*if (this.lbalt.Text!="No Altitude")
				{
					// modified 01/27/2005
					setupuitext(lbalt,"No Altitude");
				}*/
			}
			// added 01/27/2005
			/*if (Convert.ToString(dttime)!=lbltime.Text)
			{
				setupuitext(lbltime,dttime.ToLongTimeString());
			}*/
		}
		private void gps_Satellite(object sender, objSatellite[] satellites)
		{
			/*lstsats.Items.Clear();
			foreach (objSatellite sat in satellites)
			{
				lstsats.Items.Add((sat.Active?"*":" ")+" PRN: " + sat.ID + " SNR: " + sat.SNR);
			}*/

		}
		#endregion

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//gps.GpsSentence+=new OpenNETCF.IO.Serial.GPS.GPS.GpsSentenceEventHandler(gps_GpsSentence);
			gps.GpsCommState+=new OpenNETCF.IO.Serial.GPS.GPS.GpsCommStateEventHandler(gps_GpsCommState);
			gps.GpsStatus+=new OpenNETCF.IO.Serial.GPS.GPS.GpsStatusEventHandler(gps_GpsStatus);
			gps.Movement+=new OpenNETCF.IO.Serial.GPS.GPS.MovementEventHandler(gps_Movement);
			gps.Fix+=new OpenNETCF.IO.Serial.GPS.GPS.FixEventHandler(gps_Fix);
			gps.Satellite+=new OpenNETCF.IO.Serial.GPS.GPS.SatelliteEventHandler(gps_Satellite);
			//gps.Error+=new OpenNETCF.IO.Serial.GPS.GPS.ErrorEventHandler(gps_Error);
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mainMenu2 = new System.Windows.Forms.MainMenu();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.SetupGPS = new System.Windows.Forms.MenuItem();
			this.ServiceSetup = new System.Windows.Forms.MenuItem();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.start = new System.Windows.Forms.Button();
			this.ExitMessenger = new System.Windows.Forms.MenuItem();
			// 
			// mainMenu2
			// 
			this.mainMenu2.MenuItems.Add(this.menuItem4);
			this.mainMenu2.MenuItems.Add(this.menuItem1);
			this.mainMenu2.MenuItems.Add(this.ExitMessenger);
			// 
			// menuItem4
			// 
			this.menuItem4.Text = "Start Messenger";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.MenuItems.Add(this.SetupGPS);
			this.menuItem1.MenuItems.Add(this.ServiceSetup);
			this.menuItem1.Text = "Options";
			// 
			// SetupGPS
			// 
			this.SetupGPS.Text = "Setup GPS";
			this.SetupGPS.Click += new System.EventHandler(this.SetupGPS_Click);
			// 
			// ServiceSetup
			// 
			this.ServiceSetup.Text = "Service Setup";
			this.ServiceSetup.Click += new System.EventHandler(this.ServiceSetup_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, -32);
			this.pictureBox1.Size = new System.Drawing.Size(240, 312);
			// 
			// start
			// 
			this.start.Location = new System.Drawing.Point(152, 240);
			this.start.Text = "start";
			this.start.Click += new System.EventHandler(this.start_Click);
			// 
			// ExitMessenger
			// 
			this.ExitMessenger.Text = "Exit";
			this.ExitMessenger.Click += new System.EventHandler(this.ExitMessenger_Click);
			// 
			// Form1
			// 
			this.Controls.Add(this.start);
			this.Controls.Add(this.pictureBox1);
			this.Menu = this.mainMenu2;
			this.Text = "Location based Messenger";

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void start_Click(object sender, System.EventArgs e)
		{
			switch (gps.State)
			{
				case OpenNETCF.IO.Serial.GPS.States.Running:
				{
					//status("Stopping GPS");
					gps.Stop();
					break;
				}
				case OpenNETCF.IO.Serial.GPS.States.Stopped:
				{
					//status("Starting GPS");
					switch (settings.BaudRate)
					{
						case "1200":
							gps.BaudRate=OpenNETCF.IO.Serial.BaudRates.CBR_1200;
							break;
						case "4800":
							gps.BaudRate=OpenNETCF.IO.Serial.BaudRates.CBR_4800;
							break;
						case "9600":
							gps.BaudRate=OpenNETCF.IO.Serial.BaudRates.CBR_9600;
							break;
						case "19200":
							gps.BaudRate=OpenNETCF.IO.Serial.BaudRates.CBR_19200;
							break;
						default:
							break;
					}

					gps.ComPort=settings.ComPort;
					gps.AutoDiscovery=settings.AutoDiscovery;
					
					/*
					// switch our trace on if required
					gps.TraceOn=settings.TraceOn;
					gps.TraceFile=settings.TraceFile;

					// switch our demo mode on if required
					gps.DemoModeOn=settings.DemoModeOn;
					gps.DemoFile=settings.DemoFile;
					*/
					// start the GPS
					
					gps.Start();
					break;
				}
				default:
					//status("GPS is "+gps.State.ToString());
					break;
			}
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			start_Click(sender,e);
		}

		private void SetupGPS_Click(object sender, System.EventArgs e)
		{
			GPSSettings x = new GPSSettings();
			x.ShowDialog();

		}

		private void ServiceSetup_Click(object sender, System.EventArgs e)
		{
			ServiceSettings x = new ServiceSettings();
			x.ShowDialog();
		}

		private void ExitMessenger_Click(object sender, System.EventArgs e)
		{
			Application.DoEvents();
			// New 31/01/05
			exit=true;
			if (gps.State==OpenNETCF.IO.Serial.GPS.States.Running)
			{
				gps.Stop();
			}
			Cursor.Show();
			while (gps.State!=States.Stopped)
			{

				Thread.Sleep(10);
			}
			Cursor.Hide();
			Application.Exit();
		}

	}
}
