using System;
using OpenNETCF.IO.Serial;
using System.Text;
using System.Collections;
using System.Threading;
using System.IO;
using System.Globalization;

/// <summary>
/// Produced Under the Terms Of The OpennetCF License
/// 
/// By Richard Jones - Richard@BinaryRefinery.com
/// 
/// </summary>
namespace OpenNETCF.IO.Serial.GPS
{

	public class objPosition
	{
		// position stuff
		decimal latitude_fractional=0;
		string latitude_sexagesimal="";
		decimal latitude_decimal=0;
		decimal geoidseparation=0;
		CardinalDirection latitude_direction=CardinalDirection.North;

		decimal longitude_fractional=0;
		string longitude_sexagesimal="";
		decimal longitude_decimal=0;
		CardinalDirection longitude_direction=CardinalDirection.West;

		decimal altitude=0;
		DateTime sattime=DateTime.MinValue;

		#region properties
		public string Latitude_Sexagesimal
		{
			get
			{
				return latitude_sexagesimal;
			}
		}

		public string Longitude_Sexagesimal
		{
			get
			{
				return longitude_sexagesimal;
			}

		}

		public CardinalDirection DirectionLongitude
		{
			get
			{
				return longitude_direction;
			}
			set
			{
				longitude_direction=value;
			}
		}

		public CardinalDirection DirectionLatitude
		{
			get
			{
				return latitude_direction;
			}
			set
			{
				latitude_direction=value;
			}
		}

		public decimal GeoidSeparation
		{
			get
			{
				return geoidseparation;
			}
			set
			{
				geoidseparation=value;
			}
		}

		public decimal Latitude_Fractional
		{
			get
			{
				return latitude_fractional;
			}
			set
			{
				latitude_fractional=value;
				latitude_sexagesimal=Misc.DecimalToSexagesimal(value);
				latitude_decimal=Misc.FractionalToDecimalDegrees(value);
			}

		}

		public decimal Latitude_Decimal
		{
			get
			{
				return latitude_decimal;
			}
			set
			{
				Latitude_Fractional=Misc.DecimalToFractionalDegrees(value);
			}
		}

		public decimal Longitude_Fractional
		{
			get
			{
				return longitude_fractional;
			}
			set
			{
				longitude_fractional=value;
				longitude_sexagesimal=Misc.DecimalToSexagesimal(value);
				longitude_decimal=Misc.FractionalToDecimalDegrees(value);

			}

		}

		public decimal Longitude_Decimal
		{
			get
			{
				return longitude_decimal;
			}
			set
			{
				Longitude_Fractional=Misc.DecimalToFractionalDegrees(value);
			}
		}

		public decimal Altitude
		{
			get
			{
				return altitude;
			}
			set
			{
				altitude=value;
			}
		}

		public DateTime SatTime
		{
			get
			{
				return sattime;
			}
			set
			{
				sattime=value;
			}
		}

		#endregion
	}
}
